package rules2cp.examples.nqueens;
import static rules2cp.interpreter.java.r2cp.*;
import rules2cp.interpreter.java.*;
import java.util.Vector;
import static choco.Choco.*;
import choco.cp.model.CPModel;
import choco.cp.solver.CPSolver;
import choco.cp.solver.search.integer.varselector.*;
import choco.cp.solver.search.integer.valselector.*;
import choco.cp.solver.search.integer.valiterator.*;
import choco.cp.solver.search.integer.branching.*;
import choco.cp.solver.constraints.integer.*;
import choco.cp.solver.constraints.global.geost.Constants;
import choco.cp.solver.constraints.global.geost.externalConstraints.ExternalConstraint;
import choco.cp.solver.constraints.global.geost.externalConstraints.NonOverlapping;
import choco.cp.solver.constraints.global.geost.geometricPrim.ShiftedBox;
import choco.kernel.model.Model;
import choco.kernel.model.constraints.*;
import choco.kernel.model.variables.*;
import choco.kernel.model.variables.integer.*;
import choco.kernel.model.variables.geost.GeostObject;
import choco.kernel.solver.Solver;
import choco.kernel.solver.branch.*;
import choco.kernel.solver.variables.integer.*;
import choco.kernel.model.variables.geost.*;

public class queens {

  public static void main(String[] args) {

    IntegerVariable q_1 = rcp_var("from(q(1), 1)");
    IntegerVariable q_2 = rcp_var("from(q(2), 1)");
    IntegerVariable q_3 = rcp_var("from(q(3), 1)");
    IntegerVariable q_4 = rcp_var("from(q(4), 1)");
    domain(new IntegerVariable[] {q_1, q_2, q_3, q_4}, 1, 4);
    addConstraint(allDifferent(new IntegerVariable[] {q_1, q_2, q_3, q_4}));
    addConstraint(neq(q_1, plus(1, q_2)));
    addConstraint(neq(q_1, plus(-1, q_2)));
    addConstraint(neq(q_1, plus(2, q_3)));
    addConstraint(neq(q_1, plus(-2, q_3)));
    addConstraint(neq(q_1, plus(3, q_4)));
    addConstraint(neq(q_1, plus(-3, q_4)));
    addConstraint(neq(q_2, plus(1, q_3)));
    addConstraint(neq(q_2, plus(-1, q_3)));
    addConstraint(neq(q_2, plus(2, q_4)));
    addConstraint(neq(q_2, plus(-2, q_4)));
    addConstraint(neq(q_3, plus(1, q_4)));
    addConstraint(neq(q_3, plus(-1, q_4)));
    Solver s = new CPSolver();
    s.read(rules2cp.interpreter.java.r2cp.model);
    CPSolver.setVerbosity(CPSolver.SEARCH);
    s.attachGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {q_1, q_2, q_3, q_4})), new IncreasingDomain()));
    s.generateSearchStrategy();
    s.launch();
    CPSolver.flushLogs();
    System.out.println(s.pretty());
    
  }

}
