package rules2cp.examples.scheduling;
import static rules2cp.interpreter.java.r2cp.*;
import rules2cp.interpreter.java.*;
import java.util.Vector;
import static choco.Choco.*;
import choco.cp.model.CPModel;
import choco.cp.solver.CPSolver;
import choco.cp.solver.search.integer.varselector.*;
import choco.cp.solver.search.integer.valselector.*;
import choco.cp.solver.search.integer.valiterator.*;
import choco.cp.solver.search.integer.branching.*;
import choco.cp.solver.constraints.integer.*;
import choco.cp.solver.constraints.global.geost.Constants;
import choco.cp.solver.constraints.global.geost.externalConstraints.ExternalConstraint;
import choco.cp.solver.constraints.global.geost.externalConstraints.NonOverlapping;
import choco.cp.solver.constraints.global.geost.geometricPrim.ShiftedBox;
import choco.kernel.model.Model;
import choco.kernel.model.constraints.*;
import choco.kernel.model.variables.*;
import choco.kernel.model.variables.integer.*;
import choco.kernel.model.variables.geost.GeostObject;
import choco.kernel.solver.Solver;
import choco.kernel.solver.branch.*;
import choco.kernel.solver.variables.integer.*;
import choco.kernel.model.variables.geost.*;

public class scheduling {

  public static void main(String[] args) {

    IntegerVariable t1 = rcp_var("from(t1, 1)");
    IntegerVariable t5 = rcp_var("from(t5, 1)");
    IntegerVariable reif = makeIntVar("reif", 0, 1);
    IntegerVariable reif_2 = makeIntVar("reif_2", 0, 1);
    IntegerVariable t2 = rcp_var("from(t2, 1)");
    IntegerVariable reif_3 = makeIntVar("reif_3", 0, 1);
    IntegerVariable t4 = rcp_var("from(t4, 1)");
    IntegerVariable t3 = rcp_var("from(t3, 1)");
    domain(new IntegerVariable[] {t1, t2, t3, t4, t5}, 0, 20);
    addConstraint(leq(plus(t1, 2), t2));
    addConstraint(leq(plus(t2, 5), t5));
    addConstraint(leq(plus(t1, 2), t3));
    addConstraint(leq(plus(t3, 4), t5));
    addConstraint(leq(plus(t1, 2), t3));
    addConstraint(leq(plus(t3, 4), t5));
    addConstraint(and(and(ifOnlyIf(eq(reif, 1), leq(plus(t2, 5), t3)), 
			  ifOnlyIf(eq(reif, 0), leq(plus(t3, 4), t2))), 
		      and(and(ifOnlyIf(eq(reif_2, 1), leq(plus(t2, 5), t4)), 
			      ifOnlyIf(eq(reif_2, 0), leq(plus(t4, 3), t2))), 
			  and(ifOnlyIf(eq(reif_3, 1), leq(plus(t3, 4), t4)), 
			      ifOnlyIf(eq(reif_3, 0), leq(plus(t4, 3), t3))))));
    Solver s = new CPSolver();
    s.read(rules2cp.interpreter.java.r2cp.model);
    CPSolver.setVerbosity(CPSolver.SEARCH);
    s.attachGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {reif, reif_2, reif_3})), new DecreasingDomain()));
    s.minimize(s.getVar(t5), true);
    CPSolver.flushLogs();
    System.out.println(s.pretty());
    
  }

}
